<template>
  <div class="dashboard-main">
    <div class="row m-0 dashboard-main-container">
      <div class="col-12 h5 mb-4">
        <!-- <span class="font-weight-bold color-blue1">TREND</span> in this day -->
      </div>
      <div class="col-12">
        <cloud
          class="d-block justify-content-center"
          :data="tagCloud"
          :fontSizeMapper="fontSizeMapper"
          :rotate="rotate"
          :onWordClick="onWordClick"
          v-if="tagCloud.length > 1"
          padding="100px"
        />
      </div>
      <!-- <div
        class="col-6 col-md-4 col-xl-3  trend-list"
        v-for="(list, count) in findDataGet"
        :key="count"
      >
        <div class="box" @click="popup(list[0])">
          {{ list[0] }}
        </div>
      </div> -->
    </div>
  </div>
</template>

<script lang="ts">
import Vue from "vue";
import Component from "vue-class-component";
import { Action, Getter, namespace } from "vuex-class";
import Cloud from "vue-d3-cloud";

const DashboardStore = namespace("dashboard");
const AuthStore = namespace("auth");

@Component({
  name: "Dashboard_Main",
  components: {
    Cloud
  }
})
export default class Dashboard_Main extends Vue {
  @DashboardStore.Action("queryTrend") queryTrend!: any;
  @DashboardStore.Action("insertTracking") insertTracking!: any;
  @DashboardStore.Getter("trendDataGet") findDataGet!: object;
  @AuthStore.Getter("userDataData") userDataData!: string;

  tagCloud: any = [];

  mounted() {
    this.queryTrend().then(() => {
      const temp: any = this.findDataGet;
      this.tagCloud = temp.map(data => {
        return {
          text: data[0],
          value: (data[1] * 3) ** 10
        };
      });
    });
  }

  fontSizeMapper(word) {
    return Math.log2(word.value) * 10;
  }

  rotate(word) {
    return word.value % 90;
  }

  onWordClick(word) {
    this.popup(word.text);
  }

  popup(tag: string) {
    this.$swal({
      type: "info",
      title: "Confirm",
      text: `Do you want to track name '${tag}' ?`,
      confirmButtonColor: "#ef476f",
      showCancelButton: true
    }).then(result => {
      if (result.value) {
        this.insertTracking({ track_name: tag, role: this.userDataData }).then(
          resp =>
            this.$swal({
              type: "success",
              title: "Success!",
              text: `Tacking tag name '${tag}'`
            })
        );
      }
    });
  }
}
</script>

<style type="scss">
.wordCloud text {
  cursor: pointer;
  transition: 0.3s ease-out;
}
.wordCloud text:hover {
  opacity: 0.5;
}
.wordCloud {
  width: 100px;
}
.wordCloud svg {
  /* width: 100%; */
}
</style>
